open Cil
open Acpibus 

let mmio_functions: string list =
  [ "readb";
    "writeb";
    "readl";
    "readw";
    "writel";
    "writew";
    "sbus_readb";
    "sbus_writeb";
    "sbus_readl";
    "sbus_readw";
    "sbus_writel";
    "sbus_writew";
    "__raw_readb";
    "__raw_readw";
    "__raw_readl";
    "__raw_readq";
    "__raw_writeb";
    "__raw_writew";
    "__raw_writel";
    "__raw_writeq";
    "ioread8";
    "ioread16";
    "ioread16be";
    "ioread32";
    "ioread32be";
    "ioread8_rep";
    "ioread16_rep";
    "ioread32_rep";
    "iowrite8";
    "iowrite16";
    "iowrite16be";
    "iowrite32";
    "iowrite32be";
    "iowrite8_rep";
	"ioremap";
	"ioremap_nocache";
	"ioport_map";

(* MTD *)
	"ReadDOC";
	"WriteDOC";

  ];; 



let portio_fns: string list =
  [     
    "outb_p";
    "outw_p";
    "outl_p";
    "outb_local";
    "outw_local";
    "outl_local";
    "outb";
	"outw";
	"outl";
	"outsb";
	"outsw";
	"outsl";
	"inb_p";
	"inw_p";
	"inl_p";
	"inb_local";
	"inw_local";
	"inl_local";
	"inb";
	"inw";
	"inl";
	"insw";
	"insb";
	"insl";
	"ioread8";
	"ioread16";
	"ioread16be";
	"ioread32";
	"ioread32be";
	"ioread8_rep";
	"ioread16_rep";
	"ioread32_rep";
	"iowrite8";
	"iowrite6";
	"iowrite16be";
	"iowrite32";
	"iowrite32be";
	"iowrite8_rep";
	"raw_pci_read";
	"raw_pci_write";
	"ioport_map";
	"ioport_resource";
	"ioport_unmap";
	];;



let dmaio_fns: string list =
  [ "dma_alloc_coherent";
    "pci_alloc_consistent";
    "dma_map_page";
    "dma_map_single";
    "dma_pool_create";
    "pci_pool_create";
    "dma_pool_alloc";
    "pci_pool_alloc";
    "dma_pool_free";
    "pci_pool_free";
    "dma_pool_destroy";
    "pci_pool_destroy";
    "pci_map_single";
    "pci_unmap_single";
	"pci_unmap_page";
	"pci_map_page";
    "sg_dma_address";
    "dma_map_sg";
    "dma_unmap_sg";
    "dma_sync_single";
    "pci_dma_sync_single";
    "dma_sync_sg";
    "pci_dma_sync_sg";
    "usb_submit_urb";
	"dma_alloc_coherent";
    "dma_free_coherent";
    "dma_alloc_writecombine";
	"dma_mark_declared_memory_occupied";
    "dma_sync";
	"_dma_sync";
	"dma_sync_single_range_for_cpu";
	"dma_sync_single_range_for_device";    
	"dma_sync_sg_for_cpu";
	"dma_sync_sg_for_device";
	"dma_cache_sync";
  ];;
    

let thread_functions: string list =
  [
  "spin_unlock_irqrestore";
  "spin_lock";
  "spin_lock_nested";
  "spin_lock_irq";
  "spinlock_check";
  "spin_unlock";
  "spin_unlock_irq";
  "spin_lock_irqrestore";
  "spin_lock_irqsave";
  "spin_unlock_irqsave";
  "spin_lock_bh";
  "spin_unlock_bh";
  "read_lock(rwlock_t *lock";
  "read_lock_irqsave";
  "read_lock_irq";
  "read_lock_bh";
  "read_unlock";
  "read_unlock_irqrestore";
  "read_unlock_irq";
  "read_unlock_bh";
  "write_lock";
  "write_lock_irqsave";
  "write_lock_irq";
  "write_lock_bh";
  "write_trylock";
  "write_unlock";
  "write_unlock_irqrestore";
  "write_unlock_irq";
  "write_unlock_bh";
  "up";
  "up_read";
  "up_write";
  "down";
  "down_read";
  "down_timeout";
  "down_trylock";
  "down_write";
  "down_write_trylock";
  "up_interruptible";
  "down_interruptible";
  "wake_up_interruptible";
  "rcu_read_lock";
  "rcu_read_unlock";
  "rcu_barrier";
  "atomic_set";
  "atomic_read";
  "atomic_add";
  "atomic_sub";
  "atomic_inc";
  "atomic_dec";
  "atomic_inc_and_test";
  "atomic_dec_and_test";
  "atomic_sub_and_test";
  "atomic_add_negative";
  "atomic_add_return";
  "atomic_sub_return";
  "atomic_inc_return";
  "atomic_dec_return";
  "set_bit";
  "clear_bit";
  "change_bit";
  "test_bit";
  "test_and_set_bit";
  "test_and_clear_bit";
  "test_and_change_bit";
  "_raw_read_lock";
  "_raw_read_lock_bh";
  "_raw_read_lock_irq";
  "_raw_read_lock_irqsave";
  "_raw_read_unlock";
  "_raw_read_unlock_bh";
  "_raw_read_unlock_irq";
  "_raw_read_unlock_irqrestore";
  "_raw_spin_lock";
  "_raw_spin_lock_nested";
  "_raw_spin_lock_bh";
  "__raw_spin_lock_init";
  "_raw_spin_lock_irq";
  "_raw_spin_lock_irqsave";
  "_raw_spin_trylock";
  "_raw_spin_trylock_bh";
  "_raw_spin_unlock";
  "_raw_spin_unlock_bh";
  "_raw_spin_unlock_irq";
  "_raw_spin_unlock_irqrestore";
  "_raw_write_lock";
  "_raw_write_lock_bh";
  "_raw_write_lock_irq";
  "_raw_write_lock_irqsave";
  "_raw_write_unlock";
  "_raw_write_unlock_bh";
  "_raw_write_unlock_irq";
  "_raw_write_unlock_irq_restore";
  "autoremove_wake_function";
  "try_acquire_console_sem";
  "kthread_create";
  "kthread_bind";
  "kthread_create";
  "kthread_should_stop";
  "kthread_stop";
  "__rt_mutex_init";
  "rt_mutex_lock";
  "rt_mutex_trylock";
  "rt_mutex_unlock";
  "__rwlock_init";
  "mutex_init";
  "mutex_lock";
  "mutex_lock_interruptible";
  "mutex_lock_killable";
  "mutex_trylock";
  "mutex_unlock";
  ];;


let event_functions: string list =
  [
  "allow_signal";
  "disallow_signal";
  "block_all_signals";
  "complete";
  "try_wait_for_completion";
  "prepare_to_wait";
  "finish_wait";
  "queue_event";
  "queueptr";
  "queue_work";
  "queue_work_on";
  "complete_all";
  "complete_and_exit";
  "complete_master_bio";
  "completion_done";
  "wait_for_completion";
  "wait_for_completion_interruptible";
  "wait_for_completion_interruptible_timeout";
  "wait_for_completion_timeout";
  "wait_for_device_probe";
  "wake_up_bit";
  "wake_up_buffer_waiter";
  "wake_up_process";
  "__wake_up_sync";
  "__wake_up";
  "wake_up_bit";
  "wake_up_buffer_waiter";
  "wake_up_process";
  "__wake_up_sync";
  "srcu_init_notifier_head";
  "srcu_notifier_call_chain";
  "srcu_notifier_chain_register";
  "srcu_notifier_chain_unregister";
  "atomic_notifier_call_chain";
  "atomic_notifier_chain_register";
  "atomic_notifier_chain_unregister";
  "blocking_notifier_call_chain";
  "blocking_notifier_chain_register";
  "blocking_notifier_chain_unregister";
  "tasklet_schedule"; 
  "destroy_workqueue";
  "schedule";
  "tasklet_hi_schedule";  
  "schedule_work";
  "schedule_work_on";
  "scheduled_delayed_work";
  "scheduled_delayed_work_on";
  "flush_work";
  "flush_workqueue";
  "flush_scheduled_work";
  "work_pending";
  "delayed_work_pending";
  "queue_ch_frame";
  "queue_cn_work";
  "queue_delayed_work";
  "queue_delayed_work_on";
  "cancel_delayed_work_sync";
  "cancel_work_sync";
  "queue_delayed_work";
  "queue_delayed_work_on";
  "flush_delayed_work";
  "flush_signals";
  "add_timer";
  "mod_timer";
  "add_timer_on"; 
  "sched_clock_idle_sleep_event";
  "sched_clock_idle_wakeup_event";
  "sched_setscheduler";
  "schedule";
  "schedule_console_callback";
  "schedule_delayed_work";
  "schedule_delayed_work_on";
  "schedule_nes_timer";
  "schedule_timeout";
  "schedule_timeout_interruptible";
  "schedule_timeout_uninterruptible";
  "schedule_work";
  "atomic_notifier_call_chain";
  "atomic_notifier_chain_register";
  "atomic_notifier_chain_unregister";
  "ev_dispatcher";
  "event_buffer_fops";
  "event_coal_div";
  "event_coal_min";
  "event_is_open";
  "__tasklet_hi_schedule";
  "tasklet_init";
  "tasklet_kill";
  "__tasklet_schedule";
  "tasklist_lock";
  ];;






let other_bus_functions: string list =
  [

(* acpi *)

(*SPI *)
"spi_message_add_tail";
"spi_read";
"spi_unregister_driver";
"spi_write";
"spi_message_init";
"spi_get_drvdata";
"spi_set_drvdata";
"spi_w8r8";
"spi_unregister_device";
"spi_dev_get";
"spi_target_match";
"spi_populate_ppr_msg";
"spi_print_msg";
"spi_dv_device_internal";
"spi_populate_width_msg";
"spi_host_match";
"spi_transport_exit";
"spi_dv_device_echo_buffer";
"spi_device_match";
"spi_dv_device_work_wrapper";
"spi_execute";
"spi_signal_to_string";
"spi_setup_transport_attrs";
"spi_transport_init";
"spi_display_xfer_agreement";
"spi_dv_device_get_echo_buffer";
"spi_target_configure";
"spi_dv_device_compare_inquiry";
"spi_release_transport";
"spi_host_configure";
"spi_attach_transport";
"spi_dv_device";
"spi_signal_to_value";
"spi_device_configure";
"spi_host_setup";
"spi_schedule_dv_device";
"spi_populate_sync_msg";
"spi_dv_retrain";
"spi_sync";
"spi_match_id";
"spi_alloc_device";
"spi_resume";
"spi_register_driver";
"spi_master_put";
"spi_drv_remove";
"spi_complete";
"spi_bus_lock";
"spi_new_device";
"spi_match_master_to_boardinfo";
"spi_suspend";
"spi_drv_shutdown";"spi_master_set_devdata";"spi_drv_probe";"spi_alloc_master";"spi_setup";"spi_master_get";"spi_async_locked";"spi_busnum_to_master";"spi_bus_unlock";"spi_master_release";"spi_write_then_read";"spi_register_master";"spi_get_device_id";"spi_add_device";"spi_uevent";"spi_dev_put";"spi_match_device";
"spi_register_board_info";"spi_async";"spi_unregister_master";"spi_sync_locked";
"spi_master_get_devdata";



(* PCI *)
   "pci_dev_driver";
   "pci_register_driver";
   "pci_unregister_driver";
   "pci_find_device";
   "pci_find_subsys";
   "pci_find_slot";
   "pci_find_class";
   "pci_is_root_bus";

   "pci_enable_device";
   "pci_enable_device_io";
   "pci_enable_device_mem"; 
   "pci_disable_device";
   "pci_set_master";
   "pci_set_mwi";
   "pci_reenable_device";
   "pcim_enable_device";
   "pcim_pin_device";
   "pci_is_enabled";
   "pci_is_managed";
   "pci_set_master";
   "pci_clear_master";
   "pci_set_pcie_reset_state";
   "pci_set_cacheline_size";
   "pci_try_set_mwi";
   "pci_intx";
   "pci_msi_off";
   "pci_set_dma_max_seg_size";
   "pci_set_dma_seg_boundary";
   "pcix_get_max_mmrbc";
   "pcix_get_mmrbc";
   "pcix_set_mmrbc";
   "pcie_get_readrq";
   "pcie_set_readrq";
   "__pci_reset_function";
   "pci_reset_function";
   "pci_update_resource";
   "pci_assign_resource";
   "pci_select_bars";

   "pci_enable_rom";
   "pci_disable_rom";
   "pci_map_rom";
   "pci_unmap_rom";
   "pci_get_rom_size";

   "pci_save_state";
   "pci_restore_state";
   "__pci_complete_power_transition";
   "pci_set_power_state";
   "pci_choose_state";
   "pci_pme_capable";
   "pci_pme_active";
   "_pci_enable_wake";
   "pci_wake_from_d3";
   "pci_target_state";
   "pci_prepare_to_sleep";
   "pci_back_from_sleep";
   "pci_dev_run_wake";

   "pci_enable_wake";
   "set_pcie_port_type";
   "set_pcie_hotplug_bridge";

   "pci_bus_find_capability";
   "pci_rescan_bus";

   "pci_read_vpd";
   "pci_write_vpd";
   "pci_vpd_truncate";
   "pci_bus_assign_resources";
   "pci_bus_size_bridges";
   "pci_claim_resource";
   "pci_assign_unassigned_resources";
   "pci_assign_unassigned_bridge_resources";
   "pdev_enable_device";
   "pdev_sort_resources";
   "pci_enable_resources";
   "pci_fixup_irqs";
   "pci_request_regions";
   "pci_request_regions_exclusive";
   "pci_release_regions";
   "pci_request_region";
   "pci_request_region_exclusive";
   "pci_release_region";
   "pci_request_selected_regions";
   "pci_request_selected_regions_exclusive";
   "pci_release_selected_regions";
   "pci_bus_add_resource";
   "pci_bus_resource_n";
   "pci_bus_remove_resources";
   "pci_bus_alloc_resource";
   "pci_enable_bridges";
   "__pci_register_driver";
   "pci_register_driver";
   "pci_unregister_driver";
   "pci_remove_behind_bridge";
   "pci_dev_driver";
   "pci_add_dynid";
   "pci_match_id";
   "pci_scan_bridge";
   
   "pci_walk_bus";
   "pci_cfg_space_size_ext";
   "pci_cfg_space_size";
   "pci_bus_max_busnr";
   "pci_set_vga_state";
   "pci_enable_msi_block";
   "pci_msi_shutdown";
   "pci_disable_msi";
   "pci_msix_table_size";
   "pci_enable_msix";
   "pci_msix_shutdown";
   "pci_disable_msix";
   "msi_remove_pci_irq_vectors";
   "pci_restore_msi_state";
   "pci_msi_enabled";
   "pcie_aspm_enabled";
   "pcie_set_ecrc_checking";
   "pcie_ecrc_get_policy";
   "pcie_set_ecrc_checking";
   "pcie_ecrc_get_policy";
   "pci_block_user_cfg_access";
   "pci_unblock_user_cfg_access";
   "pci_domain_nr";
   "pci_proc_domain";
   "pci_register_set_vga_state";
   "pci_clear_mwi";
   "pci_channel_offline";
   "pci_add_saved_cap";

   "pci_set_power_state";
   "pci_enable_wake";
   "pci_save_state";
   "pci_restore_state";
   "pci_power_name";

   "pci_pool_create";
   "pci_pool_destroy";
   "pci_pool_alloc";
   "pci_alloc_consistent";
   "pci_free_consistent";

   "pci_lost_interrupt_reason";
   "pci_find_capability";
   "pci_find_next_capability";
   "pci_find_ext_capability";
   "pci_bus_find_ext_capability";
   "pci_find_ht_capability";
   "pci_find_next_ht_capability";
   "pci_find_next_bus";
   "pci_get_device";
   "pci_get_subsys";
   "pci_get_slot";
   "pci_get_domain_bus_and_slot";
   "pci_get_class";
   "pci_bus_set_ops";

   
   "raw_pci_read";
   "raw_pci_write"; 

   "pci_bus_read_config_byte";
   "pci_bus_read_config_word";
   "pci_bus_read_config_dword";
   "pci_bus_write_config_byte";
   "pci_bus_write_config_word";
   "pci_bus_write_config_dword";
   "pci_read_config_byte";
   "pci_read_config_word";
   "pci_read_config_dword";
   "pci_write_config_byte";
   "pci_write_config_word";
   "pci_write_config_dword";
  
   "pcibios_find_device";
   "PCI_OP"; 
"__start_pci_fixups_early";
"__start_pci_fixups_enable";
"__start_pci_fixups_final";
"__start_pci_fixups_header";
"__start_pci_fixups_resume";
"__start_pci_fixups_resume_early";
"__start_pci_fixups_suspend";
"__end_pci_fixups_early";
"__end_pci_fixups_enable";
"__end_pci_fixups_final";
"__end_pci_fixups_header";
"__end_pci_fixups_resume";
"__end_pci_fixups_resume_early";
"__end_pci_fixups_suspend";



(*i2c *)
  "i2c_bit_add_bus";
  "i2c_clients_command";
  "i2c_del_adapter";
  "i2c_del_driver";
  "i2c_get_adapter";
  "i2c_master_recv";
  "i2c_master_send";
  "i2c_smbus_read_byte"; 
  "i2c_register_driver";
  "i2c_smbus_read_byte_data";
  "i2c_smbus_read_word_data";
  "i2c_smbus_read_block_data";
  "i2c_smbus_read_i2c_block_data";
  "i2c_smbus_write_i2c_block_data";
  "i2c_smbus_write_byte";
  "i2c_smbus_write_byte_data";
  "i2c_smbus_write_word_data";
  "i2c_smbus_write_block_data";
  "i2c_transfer";
  
 
  (* Platforms *)

  "platform_add_devices";
  "platform_create_bundle";
  "platform_device_add_resources";
  "platform_device_alloc";
  "platform_device_del";
  "platform_device_put";
  "platform_device_register";
  "platform_device_register_simple";
  "platform_device_unregister";
  "platform_driver_probe";
  "platform_driver_register";
  "platform_driver_unregister";
  "platform_get_irq";
  "platform_get_irq_byname";
  "platform_get_resource";

(* eisa *)
"eisa_driver_register";
"eisa_driver_unregister";
"eisa_root_register";
"EISA_bus";
"eisa_get_drvdata";
"eisa_set_drvdata";


(* usb *)
"usb_add_hcd";
"usb_alloc_coherent";
"usb_alloc_dev";
"usb_alloc_urb";
"usb_altnum_to_altsetting";
"usb_anchor_urb";
"usbatm_usb_disconnect";
"usbatm_usb_probe";
"usb_authorize_device";
"usb_buffer_map_sg";
"usb_buffer_unmap_sg";
"usb_bulk_msg";
"usb_bus_list";
"usb_bus_list_lock";
"usb_bus_type";
"usb_cache_string";
"usb_calc_bus_time";
"usb_choose_configuration";
"usb_clear_halt";
"usb_control_msg";
"usbcore_name";
"usb_create_ep_devs";
"usb_create_hcd";
"usb_create_sysfs_dev_files";
"usb_create_sysfs_intf_files";
"usb_create_sysfs_intf_files";
"usb_deauthorize_device";
"usb_debug_root";
"usb_deregister";
"usb_deregister_dev";
"usb_deregister_device_driver";
"usb_destroy_configuration";
"usb_detect_quirks";
"usbdev_file_operations";
"usb_device_groups";
"usb_device_is_owned";
"usb_device_type";
"usb_devio_cleanup";
"usb_devio_init";
"usb_disabled";
"usb_disable_device";
"usb_disable_endpoint";
"usb_disable_interface";
"usb_disconnect";
"usb_driver_claim_interface";
"usb_driver_release_interface";
"usb_driver_set_configuration";
"usb_enable_endpoint";
"usb_enable_interface";
"usb_find_alt_setting";
"usb_find_interface";
"usb_forced_unbind_intf";
"usb_free_urb";
"usbfs_cleanup";
"usbfs_conn_disc_event";
"usbfs_devices_fops";
"usbfs_driver";
"usbfs_init";
"usbfs_mutex";
"usbfs_update_special";
"usb_gadget_register_driver";
"usb_gadget_unregister_driver";
"usb_generic_driver";
"usb_get_configuration";
"usb_get_descriptor";
"usb_get_dev";
"usb_get_device_descriptor";
"__usb_get_extra_descriptor";
"usb_get_from_anchor";
"usb_get_hcd";
"usb_get_intf";
"usb_get_status";
"usb_get_urb";
"usb_hcd_alloc_bandwidth";
"usb_hcd_check_unlink_urb";
"usb_hcd_disable_endpoint";
"usb_hcd_flush_endpoint";
"usb_hcd_get_frame_number";
"usb_hcd_giveback_urb";
"usb_hc_died";
"usb_hcd_link_urb_to_ep";
"usb_hcd_pci_pm_ops";
"usb_hcd_pci_probe";
"usb_hcd_pci_remove";
"usb_hcd_pci_shutdown";
"usb_hcd_poll_rh_status";
"usb_hcd_reset_endpoint";
"usb_hcds_loaded";
"usb_hcd_submit_urb";
"usb_hcd_synchronize_unlinks";
"usb_hcd_unlink_urb";
"usb_hcd_unlink_urb_from_ep";
"usbhid_close";
"usbhid_get_power";
"usbhid_init_reports";
"usbhid_lookup_quirk";
"usbhid_open";
"usbhid_put_power";
"usbhid_quirks_exit";
"usbhid_quirks_init";
"usbhid_submit_report";
"usbhid_wait_io";
"usb_hub_claim_port";
"usb_hub_cleanup";
"usb_hub_clear_tt_buffer";
"usb_hub_init";
"usb_hub_release_all_ports";
"usb_hub_release_port";
"usb_if_device_type";
"usb_ifnum_to_if";
"usb_init_urb";
"usb_interface_groups";
"usb_kick_khubd";
"usb_kill_anchored_urbs";
"usb_kill_urb";
"usb_kill_urb_queue";
"usb_lock_device_for_reset";
"usb_major_cleanup";
"usb_major_init";
"usb_match_device";
"usb_match_id";
"usb_match_one_id";
"usb_mon_deregister";
"usb_mon_register";
"usbnet_cdc_unbind";
"usbnet_change_mtu";
"usbnet_defer_kevent";
"usbnet_disconnect";
"usbnet_generic_cdc_bind";
"usbnet_get_drvinfo";
"usbnet_get_endpoints";
"usbnet_get_ethernet_addr";
"usbnet_get_msglevel";
"usbnet_get_settings";
"usbnet_nway_reset";
"usbnet_open";
"usbnet_probe";
"usbnet_resume";
"usbnet_set_msglevel";
"usbnet_set_settings";
"usbnet_skb_return";
"usbnet_start_xmit";
"usbnet_stop";
"usbnet_suspend";
"usbnet_tx_timeout";
"usbnet_unlink_rx_urbs";
"usb_new_device";
"usb_notify_add_bus";
"usb_notify_add_device";
"usb_notify_remove_bus";
"usb_notify_remove_device";
"usb_port_resume";
"usb_port_suspend";
"usb_put_dev";
"usb_put_hcd";
"usb_put_intf";
"usb_rebind_intf";
"usb_register_dev";
"usb_register_device_driver";
"usb_register_driver";
"usb_register_notify";
"usb_release_interface_cache";
"usb_remove_device";
"usb_remove_ep_devs";
"usb_remove_hcd";
"usb_remove_sysfs_dev_files";
"usb_remove_sysfs_intf_files";
"usb_reset_configuration";
"usb_reset_device";
"usb_reset_endpoint";
"usb_resume";
"usb_root_hub_lost_power";
"usb_scuttle_anchored_urbs";
"usb_serial_bus_deregister";
"usb_serial_bus_register";
"usb_serial_bus_type";
"usb_serial_deregister";
"usb_serial_disconnect";
"usb_serial_generic_chars_in_buffer";
"usb_serial_generic_close";
"usb_serial_generic_deregister";
"usb_serial_generic_device";
"usb_serial_generic_disconnect";
"usb_serial_generic_open";
"usb_serial_generic_read_bulk_callback";
"usb_serial_generic_read_bulk_callback";
"usb_serial_generic_register";
"usb_serial_generic_release";
"usb_serial_generic_resubmit_read_urb";
"usb_serial_generic_resume";
"usb_serial_generic_write";
"usb_serial_generic_write";
"usb_serial_generic_write_bulk_callback";
"usb_serial_generic_write_room";
"usb_serial_handle_break";
"usb_serial_handle_break";
"usb_serial_handle_break";
"usb_serial_handle_sysrq_char";
"usb_serial_handle_sysrq_char";
"usb_serial_port_softint";
"usb_serial_probe";
"usb_serial_register";
"usb_serial_resume";
"usb_serial_suspend";
"usb_serial_tty_driver";
"usb_set_configuration";
"usb_set_device_state";
"usb_set_interface";
"usb_sg_cancel";
"usb_sg_init";
"usb_sg_wait";
"usb_stor_access_xfer_buf";
"usb_storage_usb_ids";
"usb_stor_Bulk_max_lun";
"usb_stor_Bulk_reset";
"usb_stor_bulk_srb";
"usb_stor_bulk_transfer_buf";
"usb_stor_bulk_transfer_sg";
"usb_stor_Bulk_transport";
"usb_stor_CB_reset";
"usb_stor_CB_transport";
"usb_stor_clear_halt";
"usb_stor_control_msg";
"usb_stor_ctrl_transfer";
"usb_stor_bulk_transfer_buf";
"usb_stor_bulk_transfer_sg";
"usb_stor_Bulk_transport";
"usb_stor_CB_reset";
"usb_stor_CB_transport";
"usb_stor_clear_halt";
"usb_stor_control_msg";
"usb_stor_ctrl_transfer";
"usb_stor_disconnect";
"usb_store_new_id";
"usb_stor_euscsi_init";
"usb_stor_host_template";
"usb_stor_huawei_e220_init";
"usb_stor_invoke_transport";
"usb_stor_pad12_command";
"usb_stor_post_reset";
"usb_stor_pre_reset";
"usb_stor_probe1";
"usb_stor_probe2";
"usb_stor_report_bus_reset";
"usb_stor_report_device_reset";
"usb_stor_reset_resume";
"usb_stor_resume";
"usb_stor_sense_invalidCDB";
"usb_stor_set_xfer_buf";
"usb_stor_stop_transport";
"usb_stor_suspend";
"usb_stor_transparent_scsi_command";
"usb_stor_ucr61s2b_init";
"usb_stor_ufi_command";
"usb_string";
"usb_submit_urb";
"usb_suspend";
"usb_unanchor_urb";
"usb_unlink_urb";
"usb_unregister_notify";
"usb_usual_check_type";
"usb_usual_clear_present";
"usb_usual_ignore_device";
"usb_usual_ignore_device";
"usb_usual_set_present";
"usb_wait_anchor_empty_timeout";

(* pnp *)
"pnp_add_mem_resource";
"pnp_alloc";
"pnp_alloc_card";
"pnp_alloc_dev";
"pnp_auto_config_dev";
"pnpbios_calls_init";
"pnp_bios_dev_node_info";
"pnp_bios_dock_station_info";
"pnpbios_dont_use_current_config";
"pnp_bios_escd_info";
"pnp_bios_get_dev_node";
"pnp_bios_get_stat_res";
"pnpbios_interface_attach_device";
"pnp_bios_isapnp_config";
"pnpbios_parse_data_stream";
"pnp_bios_present";
"pnpbios_print_status";
"pnpbios_proc_init";
"pnp_bios_read_escd";
"pnpbios_read_resources_from_node";
"pnp_bios_set_dev_node";
"pnpbios_write_resources_to_node";
"pnp_bus_type";
"pnp_cards";
"pnp_check_dma";
"pnp_check_irq";
"pnp_check_mem";
"pnp_check_port";
"pnp_debug";
"pnp_device_attach";
"pnp_device_detach";
"pnp_disable_dev";
"pnp_eisa_id_to_string";
"pnp_find_dev";
"pnp_fixup_device";
"pnp_free_options";
"pnp_free_resource";
"pnp_free_resources";
"pnp_get_resource";
"pnp_global";
"pnp_init_resources";
"pnp_interface_attrs";
"pnp_is_active";
"pnp_lock";
"pnp_option_priority_name";
"pnp_platform_devices";
"pnp_possible_config";
"pnp_range_reserved";
"pnp_register_dma_resource";
"pnp_register_driver";
"pnp_register_irq_resource";
"pnp_register_mem_resource";
"pnp_register_port_resource";
"pnp_register_protocol";
"__pnp_remove_device";
"pnp_res_mutex";
"pnp_resource_type";
"pnp_resource_type_name";
"pnp_start_dev";
"pnp_stop_dev";
"pnp_unregister_driver";
"compare_pnp_id";
(* serio *)

"serio_close";
"serio_interrupt";
"serio_open";
"serio_reconnect";
"__serio_register_driver";
"__serio_register_port";
"serio_unregister_child_port";
"serio_unregister_driver";
"serio_unregister_port";


"__scsi_add_device"; 
"scsi_add_device"; 
"scsi_add_host_with_dma"; 
"scsi_adjust_queue_depth"; 
"scsi_allocate_command"; 
"__scsi_alloc_queue"; 
"scsi_alloc_queue"; 
"scsi_bios_ptable"; 
"scsi_block_requests"; 
"scsi_block_when_processing_errors"; 
"scsi_build_sense_buffer"; 
"scsi_bus_type"; 
"scsi_cmd_ioctl"; 
"scsi_command_normalize_sense"; 
"scsi_command_size_tbl"; 
"scsi_decide_disposition"; 
"scsi_destroy_command_freelist"; 
"scsi_device_get"; 
"scsi_device_lookup"; 
"scsi_device_lookup_by_target"; 
"scsi_device_put"; 
"scsi_device_quiesce"; 
"scsi_device_resume"; 
"scsi_device_set_state"; 
"scsi_device_state_name"; 
"scsi_device_type"; 
"scsi_device_unbusy"; 
"scsi_dev_info_add_list"; 
"scsi_dev_info_list_add_keyed"; 
"scsi_dev_info_remove_list"; 
"scsi_dh_activate"; 
"scsi_dh_attach"; 
"scsi_dh_detach"; 
"scsi_dh_handler_exist"; 
"scsi_dh_set_params"; 
"scsi_dispatch_cmd"; 
"scsi_dma_map"; 
"scsi_dma_unmap"; 
"scsi_eh_finish_cmd"; 
"scsi_eh_flush_done_q"; 
"scsi_eh_get_sense"; 
"scsi_eh_prep_cmnd"; 
"scsi_eh_ready_devs"; 
"scsi_eh_restore_cmnd"; 
"scsi_eh_scmd_add"; 
"scsi_eh_wakeup"; 
"scsi_error_handler"; 
"scsi_evt_thread"; 
"scsi_execute"; 
"scsi_execute_req"; 
"scsi_exit_devinfo"; 
"scsi_exit_hosts"; 
"scsi_exit_procfs"; 
"scsi_exit_queue"; 
"scsi_exit_sysctl"; 
"scsi_finish_command"; 
"scsi_flush_work"; 
"scsi_forget_host"; 
"scsi_free_command"; 
"scsi_free_host_dev"; 
"scsi_free_queue"; 
"__scsi_get_command"; 
"scsi_get_command"; 
"scsi_get_device_flags"; 
"scsi_get_device_flags_keyed"; 
"scsi_get_host_dev"; 
"scsi_get_sense_info_fld"; 
"scsi_get_vpd_page"; 
"scsi_host_alloc"; 
"scsi_host_get"; 
"scsi_host_get_command"; 
"scsi_host_lookup"; 
"scsi_host_put"; 
"scsi_host_put_command"; 
"scsi_host_set_state"; 
"scsi_host_state_name"; 
"scsi_init_devinfo"; 
"scsi_init_hosts"; 
"scsi_init_io"; 
"scsi_init_procfs"; 
"scsi_init_queue"; 
"scsi_init_sysctl"; 
"scsi_internal_device_block"; 
"scsi_internal_device_unblock"; 
"scsi_io_completion"; 
"scsi_ioctl"; 
"scsi_is_fc_rport"; 
"scsi_is_host_device"; 
"scsi_is_sdev_device"; 
"scsi_is_target_device"; 
"__scsi_iterate_devices"; 
"scsi_kmap_atomic_sg"; 
"scsi_kunmap_atomic_sg"; 
"scsi_log_completion"; 
"scsi_logging_level"; 
"scsi_log_send"; 
"scsi_mode_select"; 
"scsi_mode_sense"; 
"scsi_netlink_exit"; 
"scsi_netlink_init"; 
"scsi_next_command"; 
"scsi_nl_sock"; 
"scsi_nonblockable_ioctl"; 
"scsi_noretry_cmd"; 
"scsi_normalize_sense"; 
"scsi_partsize"; 
"scsi_prep_fn"; 
"blank_transport_template";
"scsi_prep_return"; 
"__scsi_print_command"; 
"scsi_print_command"; 
"scsi_print_result"; 
"__scsi_print_sense"; 
"scsi_print_sense"; 
"scsi_print_sense_hdr"; 
"scsi_proc_host_add"; 
"scsi_proc_hostdir_add"; 
"scsi_proc_hostdir_rm"; 
"scsi_proc_host_rm"; 
"__scsi_put_command"; 
"scsi_put_command"; 
"scsi_queue_insert"; 
"scsi_queue_work"; 
"scsi_register"; 
"scsi_register_device_handler"; 
"scsi_register_driver"; 
"scsi_register_interface"; 
"scsi_release_buffers"; 
"__scsi_remove_device"; 
"scsi_remove_device"; 
"scsi_remove_host"; 
"scsi_remove_target"; 
"scsi_report_bus_reset"; 
"scsi_report_device_reset"; 
"scsi_rescan_device"; 
"scsi_reset_provider"; 
"scsi_run_host_queues"; 
"scsi_scan_host"; 
"scsi_scan_host_selected"; 
"scsi_scan_target"; 
"scsi_schedule_eh"; 
"scsi_sdb_cache"; 
"scsi_sense_desc_find"; 
"scsi_set_medium_removal"; 
"scsi_setup_blk_pc_cmnd"; 
"scsi_setup_command_freelist"; 
"scsi_setup_fs_cmnd"; 
"scsi_show_extd_sense"; 
"scsi_show_result"; 
"scsi_show_sense_hdr"; 
"scsi_sysfs_add_host"; 
"scsi_sysfs_add_sdev"; 
"scsi_sysfs_device_initialize"; 
"scsi_sysfs_register"; 
"scsi_sysfs_shost_attr_groups"; 
"scsi_sysfs_unregister"; 
"scsi_target_block"; 
"scsi_target_quiesce"; 
"scsi_target_reap"; 
"scsi_target_resume"; 
"scsi_target_unblock"; 
"scsi_test_unit_ready"; 
"scsi_tgt_cmd_to_host"; 
"scsi_tgt_if_exit"; 
"scsi_tgt_if_init"; 
"scsi_tgt_it_nexus_create"; 
"scsi_tgt_it_nexus_destroy"; 
"scsi_tgt_kspace_exec"; 
"scsi_tgt_kspace_it_nexus_rsp"; 
"scsi_tgt_kspace_tsk_mgmt"; 
"scsi_tgt_queue_command"; 
"scsi_tgt_uspace_send_cmd"; 
"scsi_tgt_uspace_send_it_nexus_request"; 
"scsi_tgt_uspace_send_status"; 
"scsi_tgt_uspace_send_tsk_mgmt"; 
"scsi_times_out"; 
"scsi_track_queue_full"; 
"scsi_unblock_requests"; 
"scsi_unregister"; 
"scsi_unregister_device_handler"; 
(* ide *) 
"ide_acpi_exec_tfs"; 
"ide_acpi_get_timing"; 
"ide_acpi_init"; 
"ide_acpi_init_port"; 
"ide_acpi_port_init_devices"; 
"ide_acpi_push_timing"; 
"ide_acpi_set_state"; 
"ide_allocate_dma_engine"; 
"ide_ata_disk_ops"; 
"ide_atapi_disk_ops"; 
"ide_build_dmatable"; 
"ide_bus_type"; 
"ide_capacity_proc_fops"; 
"ide_cd_expiry"; 
"ide_cd_log_error"; 
"ide_cd_queue_pc"; 
"ide_cd_read_toc"; 
"ide_cdrom_audio_ioctl"; 
"ide_cdrom_check_media_change_real"; 
"ide_cdrom_drive_status"; 
"ide_cdrom_get_capabilities"; 
"ide_cdrom_get_last_session"; 
"ide_cdrom_get_mcn"; 
"ide_cdrom_lock_door"; 
"ide_cdrom_open_real"; 
"ide_cdrom_packet"; 
"ide_cdrom_release_real"; 
"ide_cdrom_reset"; 
"ide_cdrom_select_speed"; 
"ide_cdrom_tray_move"; 
"ide_cdrom_update_speed"; 
"ide_check_atapi_device"; 
"ide_check_dma_crc"; 
"ide_check_ireason"; 
"ide_check_nien_quirk_list"; 
"ide_check_pm_state"; 
"ide_complete_cmd"; 
"ide_complete_pm_rq"; 
"ide_complete_rq"; 
"ide_config_drive_speed"; 
"ide_create_request_sense_cmd"; 
"ide_dev_attrs"; 
"ide_device_get"; 
"ide_device_put"; 
"ide_dev_read_id"; 
"ide_devset_acoustic"; 
"ide_devset_address"; 
"ide_devset_execute"; 
"ide_devset_io_32bit"; 
"ide_devset_keepsettings"; 
"ide_devset_multcount"; 
"ide_devset_nowerr"; 
"ide_devset_pio_mode"; 
"ide_devset_unmaskirq"; 
"ide_devset_using_dma"; 
"ide_devset_wcache"; 
"ide_disk_ioctl"; 
"ide_disk_proc"; 
"ide_disk_settings"; 
"__ide_dma_bad_drive"; 
"ide_dma_end"; 
"ide_dma_good_drive"; 
"ide_dma_host_set"; 
"ide_dma_intr"; 
"ide_dma_lost_irq"; 
"ide_dma_off"; 
"ide_dma_off_quietly"; 
"ide_dma_on"; 
"ide_dma_prepare"; 
"ide_dma_setup"; 
"ide_dma_sff_read_status"; 
"ide_dma_sff_timer_expiry"; 
"ide_dma_start"; 
"ide_dma_test_irq"; 
"ide_dma_timeout_retry"; 
"ide_dma_unmap_sg"; 
"ide_do_devset"; 
"ide_do_park_unpark"; 
"ide_do_reset"; 
"ide_do_start_stop"; 
"ide_do_test_unit_ready"; 
"ide_driveid_update"; 
"ide_dump_status"; 
"ide_end_rq"; 
"ide_error"; 
"ide_exec_command"; 
"ide_execute_command"; 
"ide_find_dma_mode"; 
"ide_finish_cmd"; 
"ide_fix_driveid"; 
"ide_fixstring"; 
"ide_floppy_create_mode_sense_cmd"; 
"ide_floppy_create_read_capacity_cmd"; 
"ide_floppy_ioctl"; 
"ide_floppy_proc"; 
"ide_floppy_settings"; 
"ide_gd_capacity"; 
"ide_geometry_proc_fops"; 
"ide_get_lba_addr"; 
"ide_host_add"; 
"ide_host_alloc"; 
"ide_host_free"; 
"ide_host_register"; 
"ide_host_remove"; 
"ide_hwif_setup_dma"; 
"ide_in_drive_list"; 
"ide_init_disk"; 
"ide_init_pc"; 
"ide_init_sg_cmd"; 
"ide_input_data"; 
"ide_intr"; 
"ide_issue_pc"; 
"ide_kill_rq"; 
"ide_legacy_device_add"; 
"ide_map_sg"; 
"ide_media_string"; 
"ide_no_data_taskfile"; 
"ide_output_data"; 
"ide_pad_transfer"; 
"ide_park_show"; 
"ide_park_store"; 
"ide_park_wq"; 
"ide_pci_check_simplex"; 
"ide_pci_clk"; 
"ide_pci_dma_base"; 
"ide_pci_init_one"; 
"ide_pci_init_two"; 
"__ide_pci_register_driver"; 
"ide_pci_remove"; 
"ide_pci_resume"; 
"ide_pci_set_master"; 
"ide_pci_setup_ports"; 
"ide_pci_suspend"; 
"ide_pio_bytes"; 
"ide_pio_cycle_time"; 
"ide_pio_need_iordy"; 
"ide_port_acpi"; 
"ide_port_apply_params"; 
"ide_port_class"; 
"ide_port_scan"; 
"ide_port_unregister_devices"; 
"ide_prep_sense"; 
"ide_proc_port_register_devices"; 
"ide_proc_register_driver"; 
"ide_proc_register_port"; 
"ide_proc_unregister_device"; 
"ide_proc_unregister_driver"; 
"ide_proc_unregister_port"; 
"ide_queue_pc_tail"; 
"ide_queue_sense_rq"; 
"ide_raw_taskfile"; 
"ide_read_altstatus"; 
"ide_read_bcount_and_ireason"; 
"ide_read_error"; 
"ide_read_status"; 
"ide_register_region"; 
"ide_release_dma_engine"; 
"ide_requeue_and_plug"; 
"ide_retry_pc"; 
"ide_scan_pio_blacklist"; 
"ide_set_dma"; 
"ide_set_dma_mode"; 
"__ide_set_handler"; 
"ide_set_handler"; 
"ide_set_media_lock"; 
"ide_set_pio"; 
"ide_setting_ioctl"; 
"ide_setting_mtx"; 
"ide_setup_pci_noise"; 
"ide_set_xfer_rate"; 
"ide_stall_queue"; 
"ide_start_power_step"; 
"ide_sysfs_register_port"; 
"ide_taskfile_ioctl"; 
"ide_tf_dump"; 
"ide_tf_load"; 
"ide_tf_read"; 
"ide_tf_readback"; 
"ide_timer_expiry"; 
"ide_timing_compute"; 
"ide_timing_find_mode"; 
"ide_timing_merge"; 
"ide_toggle_bounce"; 
"ide_unregister_region"; 
"ide_vlb_clk"; 
"ide_wait_not_busy"; 
"__ide_wait_stat"; 
"ide_wait_stat"; 
"ide_write_devctl"; 
"ide_xfer_verbose"; 
"generic_ide_ioctl";
"generic_ide_resume";
"generic_ide_suspend";


"bus_add_device";
"bus_add_driver";
"bus_create_file";
"buses_init";
"bus_find_device";
"bus_find_device_by_name";
"bus_for_each_dev";
"bus_for_each_drv";
"bus_get_kset";
"bus_probe_device";
"bus_register";
"bus_register_notifier";
"bus_remove_device";
"bus_remove_driver";
"bus_remove_file";
"bus_rescan_devices";
"bus_sort_breadthfirst";
"bus_unregister";
"bus_unregister_notifier";

(* xenbus *)

"unregister_xenbus_watch"; 
"xenbus_dev_fatal"; 
"xenbus_frontend_closed"; 
"xenbus_grant_ring"; 
"xenbus_printf"; 
"xenbus_read"; 
"xenbus_register_frontend"; 
"xenbus_scanf"; 
"xenbus_switch_state"; 
"xenbus_transaction_end"; 
"xenbus_transaction_start"; 
"xenbus_unregister_driver"; 
"xenbus_watch_path2"; 


"scsifront_xenbus_init";
"scsifront_xenbus_unregister";
"xenbus_directory";
"xenbus_frontend_closed";
"xenbus_read_driver_state";



(* bus functions end *)

  
  ];;



let alloc_fns: string list =
  [ "kmalloc";
"kmalloc_caches";
"__kmalloc_track_caller";
    "kmem_cache_alloc";
    "kzalloc";
	"kzfree";
	"krealloc";
	"__kmalloc";
    "kmalloc_large";
    "kmalloc_slab";
    "kmalloc_index";
    "trace_kmalloc";
    "alloc_skb";
    "kcalloc";
    "vmalloc";
    "kmemleak_alloc";
    "kmem_cache_zalloc";
    "kmem_cache_alloc";
    "deinit_kmem_cache";
    "__get_free_pages";
    "__alloc_pages";
	"alloc_pages";
    "alloc_percpu";
    "alloc_bootmem";
    "alloc_netdev";
    "usb_buffer_alloc";
  (*   "ioremap"; *)
    "usb_alloc_skb";
    "__vmalloc";
    "vmalloc_32";
    "vmalloc_node";
    "vmalloc_to_page";
    "vmalloc_to_pfn";
    "vmalloc_user";

	"kmem_cache_alloc_notrace";
	"kmem_cache_create";

	(* More alloc fns + memory fns *)
	"mempool_alloc";
	"mempool_alloc_pages";
	"mempool_alloc_slab";
	"mempool_create";
	"mempool_destroy";
	"mempool_free";
	"mempool_free_pages";
	"mempool_free_slab";
	"mempool_kfree";
	"mempool_kmalloc";
	"mempool_resize";
	"kmem_cache_alloc";
	"kmem_cache_alloc_notrace";
	"kmem_cache_create";
	"kmem_cache_destroy";
	"kmem_cache_free";
	"kmem_cache_shrink";
	"get_user_pages";
	"get_zeroed_page";

(*
	"dma_alloc_from_coherent";
	"dmam_pool_create";
	"dma_pool_alloc";
	"dma_pool_create";
	"dma_pool_destroy";
	"dma_pool_free";
	"dma_region_alloc";
	"dma_region_free";
	"dma_region_init";
	"dma_region_mmap";
	"dma_release_declared_memory";
	"dma_release_from_coherent";
*)

	"gen_pool_add";
	"gen_pool_alloc";
	"gen_pool_create";
"gen_pool_destroy";
"gen_pool_free";
"kfree";
"vfree";


"free_buffer_head";
"free_cpu_buffers";
"free_dca_provider";
"free_dma";
"__free_ep";
"free_event_buffer";
"free_irq";
"free_netdev";

"free_pages";
"alloc_pages_node";
"__free_pages";
"free_pages";

"free_percpu";
"free_task";
"free_tty_struct";

"__alloc_bootmem";
"alloc_chrdev_region";
"alloc_cpu_buffers";
"alloc_dca_provider";
"alloc_disk";
"alloc_page";
"alloc_disk_node";
"alloc_tty_struct";
"alloc_page_buffers";
"__alloc_pages_nodemask";

  ];;


let alloc_dev: string list =
[
"alloc_netdev";
"__alloc_ei_netdev";
"__alloc_eip_netdev";
"alloc_etherdev_mq";
"alloc_event_buffer";
"alloc_fddidev";
"alloc_hdlcdev";
"alloc_hippi_dev";
"alloc_ieee80211";
"alloc_mcc_tag";
"alloc_netdev_mq";
"alloc_orinocodev";
"alloc_pci_dev";
"alloc_trdev";
"cdev_add";
"clockevents_register_device";
"hwmon_device_register";
"platform_device_register";
"platform_device_register_simple";
"usb_register_device_driver";
"scsi_register_device_handler"; 
"ide_proc_port_register_devices"; 
"clockevents_register_device";
"hwmon_device_register";
"device_register";
"usb_alloc_dev";
];;

let kernel_helper_libs1: string list =
[
"get_driver";
"get_field";
"get_jiffies_64";

"hweight16";
"hweight32";
"hweight64";
"hweight8";

"in_aton";
"intlog10";
"int_sqrt";
"clockevent_delta2ns";
"clockevents_notify";

"simple_strtol";
"simple_strtoul";
"simple_strtoull";
"single_open";
"snprintf";
"sprintf";
"sq_size";
"srandom32";
"sscanf";
"sync_start";
"sync_stop";
"sys_copyarea";
"system_state";
"taskfile_lib_get_identify";

"bitmap_allocate_region";
"__bitmap_and";
"__bitmap_andnot";
"bitmap_close_sync";
"__bitmap_complement";
"bitmap_cond_end_sync";
"bitmap_copy_le";
"bitmap_create";
"bitmap_daemon_work";
"bitmap_destroy";
"bitmap_dirty_bits";
"__bitmap_empty";
"bitmap_end_sync";
"bitmap_endwrite";
"__bitmap_equal";
"bitmap_find_free_region";
"bitmap_find_next_zero_area";
"bitmap_flush";
"__bitmap_full";
"__bitmap_intersects";
"__bitmap_or";
"bitmap_parselist";
"bitmap_print_sb";
"bitmap_release_region";
"bitmap_scnlistprintf";
"bitmap_scnprintf";
"__bitmap_shift_right";
"bitmap_start_sync";
"bitmap_startwrite";
"__bitmap_subset";
"__bitmap_or";
"__bitmap_and";
"__bitmap_xor";
"__bitmap_xand";
"__bitmap_subset";
"bitmap_unplug";
"bitmap_update_sb";
"__bitmap_weight";
"bitmap_write_all";
"zero_fill_bio";
"zlib_deflate";
"zlib_deflateEnd";
"zlib_deflateInit2";
"zlib_deflateReset";
"zlib_deflate_workspacesize";
"zlib_inflate";
"zlib_inflateEnd";
"zlib_inflateIncomp";
"zlib_inflateInit2";
"zlib_inflateReset";
"zlib_inflate_workspacesize";

"strcat";
"strchr";
"strcmp";
"strcpy";
"strcspn";
"strict_strtol";
"strict_strtoll";
"strict_strtoul";
"strict_strtoull";
"strict_strtoul_scaled";
"strim";
"string_get_size";
"strlcat";
"strlcpy";
"strlen";
"strncasecmp";
"strncat";
"strncmp";
"strncpy";
"strncpy_from_user";
"strnicmp";
"strnlen";
"strnlen_user";
"strrchr";
"strsep";
"strspn";
"strstr";
"bcd2bin";
"crc16";
"crc32_be";
"crc32c";
"crc32_le";
"crc_ccitt";
"crc_ccitt_table";
"crc_itu_t";
"crc_t10dif";

"conswitchp";
"contig_page_data";
"conv_8bit_to_uni";
"conv_uni_to_8bit";
"conv_uni_to_pc";
"copybreak";
"_copy_from_user";
"__copy_from_user_ll";
"__copy_from_user_ll_nocache_nozero";
"__copy_from_user_ll_nozero";
"copy_from_user_toio";
"copy_to_user";
"copy_to_user_fromio";
"__copy_to_user_ll";
"__builtin_memcmp";
"__builtin_memcpy";
"_constant_memcpy";
"__constant_c_and_count_memset";
"memchr";
"memcmp";
"memcpy";
"memcpy_fromiovec";
"memcpy_fromiovecend";
"memcpy_toiovec";
"memcpy_toiovecend";
"memdup_user";
"mem_map";
"memmove";
"memory_read_from_buffer";
"memparse";
"param_array_get";
"param_array_set";
"param_get_bool";
"param_get_byte";
"param_get_charp";
"param_get_int";
"param_get_invbool";
"param_get_long";
"param_get_short";
"param_get_string";
"param_get_uint";
"param_get_ulong";
"param_get_ushort";
"param_set_bool";
"param_set_byte";
"param_set_charp";
"param_set_copystring";
"param_set_int";
"param_set_invbool";
"param_set_long";
"param_set_short";
"param_set_uint";
"param_set_ulong";
"param_set_ushort";

"print_hex_dump";
"print_hex_dump_bytes";

(*
"printk";
"__printk_ratelimit";
"printk_timed_ratelimt";
"vprintk";
*)

"print_ssid";
"__print_symbol";
"vscnprintf";
"vsnprintf";
"vsprintf";
(* "dev_printk"; 

"dev_crit";
"dev_warn";
"dev_notice";
*)
"match_hex";
"match_int";
"match_octal";
"match_strdup";
"match_token";
"max_pfn";
"max_vals";
"medianame";
"minor_count";
"minor_table";

"find_first_bit";
"find_first_zero_bit";
"find_font";
"find_next_bit";
"find_next_zero_bit";
"find_vpid";

"rb_erase";
"rb_first";
"rb_insert_color";
"rb_last";
"rb_next";
"rb_replace_node";

"list_for_each";
"list_for_each_from";
"list_for_eachi_continue";
"list_for_each_safe";
"list_for_each_entry";
"_list_for_each_entry";
"list_empty";
"list_empty_careful";
"list_is_last";
"list_delete";
"list_add_tail";
"list_add";
"klist_add_tail";
"klist_de";
"klist_init";
"klist_iter_exit";
"klist_iter_init";
"klist_iter_init_node";
"klist_next";
"klist_node_attached";
"klist_remove";


"usermode_helper";
"utf16s_to_utf8s";


(*trace point functions are calls wrapped around tracepoint lib s*) 
"bitrev16";
"bitrev32";
"totalram_pages";
"kfifo_in";
"kfifo_init";
"kfifo_out";
"no_llseek";

"dcookie_register";
"dcookie_unregister";
"kasprintf";
"kmemdump";
"kstrdup";
"kstrndup";
"kmemdup";

"kmemdup";
"ktime_get";
"ktime_get_real";
"ktime_get_ts";
"kvasprintf";
"vbin_printf";
"list_sort";
"loops_per_jiffy";

"msecs_to_jiffies";

"div64_u64";


"d_rehash";
"dump_stack";
"gcd";
"gcd";
"ge2comp";
(* kernel libs *)
];;

let kernel_dev_libs = [ 

"disk_map_sector_rcu";

"inet_get_local_port_range";
"ioctl_by_bdev";
"iomem_resource";
"io_schedule";
"iov_shorten";

"set_irq_chip";
"set_irq_chip_and_handler";
"set_irq_chip_and_handler_name";
"set_irq_chip_data";
"set_irq_data";
"__set_irq_handler";
"set_irq_msi";
"set_irq_nested_thread";
"set_irq_noprobe";
"set_irq_probe";
"set_irq_type";
"set_irq_wake";
"setup_irq";

"enable_irq";



"init_net";
"__napi_complete";
"napi_complete";
"napi_get_frags";
"napi_gro_frags";
"napi_gro_receive";
"nap_schedule";
"tcp_read_sock";
"udp_prot";
"nr_irqs";
"ndisc_send_skb";
"neigh_destroy";
"__neigh_event_send";
"neigh_lookup";
"net_msg_warn";
"net_ratelimit";
"ndisc_build_skb";
"ndisc_send_skb";
"new_inode";
"udp_prot";
"probe_irq_off";
"destroy_irq";
"irq_regs";
"irq_to_desc";
"irq_to_pcap";

"local_bh_disable";
"local_bh_enable";
"create_irq_nr";
"disable_irq";
"disable_irq_nosync";



"handle_edge_irq";
"handle_nested_irq";
"handle_simple_irq";

(* xen *)

"scsifront_intr"; 
"scsifront_schedule"; 
"scsifront_sht"; 
"scsifront_xenbus_init"; 
"scsifront_xenbus_unregister"; 
"netfront_accelerator_add_watch"; 
"netfront_accelerator_call_get_stats"; 
"netfront_accelerator_call_remove"; 
"netfront_accelerator_call_stop_napi_irq"; 
"netfront_accelerator_resume"; 
"netfront_accelerator_suspend"; 
"netfront_accelerator_suspend_cancel"; 
"netfront_check_accelerator_queue_ready"; 



(* power management *)
"pm_runtime_put";
" __pm_runtime_idle";
" __pm_runtime_suspend";
" __pm_runtime_resume";
" pm_schedule_suspend";
" __pm_runtime_set_status";
"pm_runtime_barrier";
"_runtime_enable";
"__pm_runtime_disable";
"pm_runtime_allow";
"pm_runtime_forbid"; 
"pm_generic_runtime_idle";
"pm_generic_runtime_suspend";
"pm_generic_runtime_resume";
"pm_runtime_no_callbacks";
"__pm_runtime_use_autosuspend";
"pm_runtime_set_autosuspend_delay";
"pm_runtime_autosuspend_expiration";

"put_device";
"put_disk";
"put_driver";



"emergency_remount";
"emergency_restart";
"emergency_sync";
"emergency_thaw_all";


"arp_create";
"arp_find";
"arp_send";
"arp_tbl";
"arp_validate_tbl";
"arp_xmit";

(* block device support *)
"bd_claim";
"bd_claim_by_disk";
"bdevname";
"__bdevname";
"bdev_read_only";
"bdev_stack_limits";
"bdget";
"bdget_disk";
"bdi_destroy";
"bdi_init";
"bdi_register";
"bdput";
"bd_release";
"bd_release_from_disk";
"bd_set_size";
"bin2bcd";
"bio_add_page";
"bio_alloc";
"bio_alloc_bioset";
"__bio_clone";
"bio_clone";
"bio_endio";
"bio_free";
"bio_get_nr_vecs";
"bio_init";
"bio_kmalloc";
"bio_map_kern";
"bio_pair_release";
"bio_put";
"bioset_create";
"bioset_free";
"bio_split";


"firmware_init";
"firmware_kobj";
"ip6_route_output";
"ip_dev_find";
"ip_mc_rejoin_group";
"ip_queue_xmit";
"ip_route_output_flow";
"ip_route_output_key";

"iput";
"__ipv6_addr_type";
"ipv6_chk_addr";
"ipv6_dev_get_saddr";

(* skb management *)
"skb_add_rx_frag";
"skb_checksum";
"__skb_checksum_complete";
"skb_checksum_help";
"skb_clone";
"skb_copy";
"skb_copy_and_csum_dev";
"skb_copy_bits";
"skb_copy_datagram_const_iovec";
"skb_copy_datagram_from_iovec";
"skb_copy_datagram_iovec";
"skb_copy_expand";
"skb_dequeue";
"skb_free_datagram";
"skb_gso_segment";
"skb_pad";
"skb_partial_csum_set";
"skb_prepare_seq_read";
"skb_pull";
"skb_pull_rcsum";
"skb_push";
"skb_put";
"skb_queue_head";
"skb_queue_purge";
"skb_queue_tail";
"skb_realloc_headroom";
"skb_recv_datagram";
"skb_seq_read";
"skb_trim";
"skb_tstamp_tx";
"skb_tx_hash";
"skb_unlink";
"skb_abort_seq_read";
"pskb_expand_head";
"__pskb_pull_tail";
"___pskb_trim";

"sock_alloc_send_pskb";
"sock_create";
"sock_create_kern";
"sock_create_lite";
"sockfd_lookup";
"sock_init_data";
"sock_no_accept";
"sock_no_bind";
"sock_no_connect";
"sock_no_getname";
"sock_no_getsockopt";
"sock_no_listen";
"sock_no_mmap";
"sock_no_poll";
"sock_no_recvmsg";
"sock_no_sendmsg";
"sock_no_sendpage";
"sock_no_setsockopt";
"sock_no_shutdown";
"sock_no_socketpair";
"sock_queue_rcv_skb";
"sock_recvmsg";
"sock_register";
"sock_release";
"sock_unregister";
"sock_wmalloc";
"dev";
"dev2t3cdev";
"dev_add_pack";
"dev_addr_add";
"dev_addr_del";
"dev_alloc_name";
"dev_alloc_skb";
"dev_attr_beacon";
"dev_attr_cpuaffinity";
"dev_attr_cpulistaffinity";
"dev_attr_em_message";
"dev_attr_em_message_type";
"dev_attr_link_power_management_policy";
"dev_attr_mac_address";
"dev_attr_scan";
"dev_attr_sw_activity";
"dev_attr_unload_heads";
"dev_base_lock";
"dev_change_flags";
"dev_close";
"dev_driver_string";
"dev_forward_skb";
"__dev_get_by_index";
"dev_get_by_index";
"dev_get_by_index_rcu";
"__dev_get_by_name";
"dev_get_by_name";
"dev_get_by_name_rcu";
"dev_get_drvdata";
"dev_get_stats";
"device_add";
"device_attach";
"device_bind_driver";
"device_create";
"device_create_bin_file";
"device_create_file";
"device_del";
"device_destroy";
"device_find_child";
"device_for_each_child";
"device_initialize";
"device_pm_add";
"device_pm_init";
"device_pm_lock";
"device_pm_move_after";
"device_pm_move_before";
"device_pm_move_last";
"device_pm_remove";
"device_pm_unlock";
"device_pm_wait_for_dev";
"device_private_init";
"device_register";
"device_release_driver";
"device_remove_bin_file";
"device_remove_file";
"device_rename";
"device_reprobe";
"device_schedule_callback_owner";
"devices_init";
"devices_kset";
"device_unregister";
"dev_kfree_skb_any";
"dev_kfree_skb_irq";
"dev_mc_add";
"dev_mc_delete";
"dev_mc_sync";
"dev_mc_unsync";
"devm_free_irq";
"devm_ioport_map";
"devm_ioremap";
"devm_kzalloc";
"__devm_request_region";
"devm_request_threaded_irq";
"dev_open";
"devpts_get_tty";
"devpts_kill_index";
"devpts_new_index";
"devpts_pty_kill";
"devpts_pty_new";
"dev_queue_xmit";
"__dev_remove_pack";
"dev_remove_pack";
"devres_add";
"devres_alloc";
"devres_destroy";
"devres_find";
"devres_free";
"devres_get";
"devres_open_group";
"devres_release_all";
"devres_release_group";
"devres_remove_group";
"dev_set_allmulti";
"dev_set_drvdata";
"dev_set_mac_address";
"dev_set_mtu";
"dev_set_name";
"dev_set_promiscuity";
"dev_trans_start";
"dev_txq_stats_fold";
"dev_unicast_add";
"dev_unicast_delete";
"dev_valid_name";


"blk_abort_queue";
"blk_abort_request";
"blk_alloc_queue";
"blk_cleanup_queue";
"blk_complete_request";
"blkdev_aio_write";
"__blkdev_driver_ioctl";
"blkdev_fsync";
"blkdev_get";
"blkdev_ioctl";
"blkdev_issue_flush";
"blkdev_put";
"blk_dump_rq_flags";
"__blk_end_request";
"blk_end_request";
"__blk_end_request_all";
"blk_end_request_all";
"__blk_end_request_cur";
"blk_end_request_err";
"blk_execute_rq";
"blk_execute_rq_nowait";
"blk_fetch_request";
"blk_free_tags";
"blk_get_request";
"blk_init_queue";
"blk_init_queue_node";
"blk_init_tags";
"blk_insert_cloned_request";
"blk_insert_request";
"blk_iopoll_complete";
"blk_iopoll_disable";
"blk_iopoll_enable";
"blk_iopoll_enabled";
"blk_iopoll_init";
"blk_iopoll_sched";
"blk_limits_io_min";
"blk_limits_io_opt";
"blk_lld_busy";
"blk_make_request";
"blk_max_low_pfn";
"blk_peek_request";
"blk_plug_device";
"blk_plug_device_unlocked";
"__blk_put_request";
"blk_put_request";
"blk_queue_alignment_offset";
"blk_queue_bounce";
"blk_queue_bounce_limit";
"blk_queue_dma_alignment";
"blk_queue_dma_drain";
"blk_queue_find_tag";
"blk_queue_free_tags";
"blk_queue_init_tags";
"blk_queue_io_min";
"blk_queue_io_opt";
"blk_queue_lld_busy";
"blk_queue_logical_block_size";
"blk_queue_make_request";
"blk_queue_max_hw_sectors";
"blk_queue_max_segments";
"blk_queue_max_segment_size";
"blk_queue_merge_bvec";
"blk_queue_ordered";
"blk_queue_physical_block_size";
"blk_queue_prep_rq";
"blk_queue_resize_tags";
"blk_queue_rq_timed_out";
"blk_queue_rq_timeout";
"blk_queue_segment_boundary";
"blk_queue_softirq_done";
"blk_queue_stack_limits";
"blk_queue_start_tag";
"blk_queue_update_dma_alignment";
"blk_queue_update_dma_pad";
"blk_recount_segments";
"blk_register_region";
"blk_remove_plug";
"blk_requeue_request";
"blk_rq_init";
"blk_rq_map_kern";
"blk_rq_map_sg";
"blk_rq_map_user";
"blk_rq_map_user_iov";
"blk_rq_prep_clone";
"blk_rq_unmap_user";
"blk_rq_unprep_clone";
"__blk_run_queue";
"blk_run_queue";
"blk_set_default_limits";
"blk_stack_limits";
"blk_start_queue";
"blk_start_request";
"blk_stop_queue";
"blk_sync_queue";
"blk_unplug";
"blk_unregister_region";
"blk_update_request";
"blk_verify_command";
"amixer_mgr_create";
"amixer_mgr_destroy";

"sysfs_remove_files";
"sysfs_remove_group";
"sysfs_remove_link";
"sysfs_rename_link";
"sysfs_schedule_callback";
"sysfs_streq";
"sysfs_update_group";

"sysctl_tcp_dma_copybreak";
"sysctl_vfs_cache_pressure";
"sysdev_class_register";
"sysdev_class_unregister";
"sysdev_driver_register";
"sysdev_driver_unregister";
"sysdev_register";
"sys_fillrect";
"sysfs_add_file_to_group";
"sysfs_chmod_file";
"sysfs_create_bin_file";
"sysfs_create_file";
"sysfs_create_files";
"sysfs_create_group";
"sysfs_create_link";
"sysfs_dev_char_kobj";
"sysfs_format_mac";
"sysfs_get_dirent";
"sysfs_notify";
"sysfs_notify_dirent";
"sysfs_put";
"sysfs_remove_bin_file";
"sysfs_remove_file";
"sysfs_remove_file_from_group";
"sysfs_remove_files";
"sysfs_remove_group";
"sysfs_remove_link";
"sysfs_rename_link";
"sysfs_schedule_callback";
"sysfs_streq";

"driver_attach";
"driver_create_file";
"driver_detach";
"driver_find";
"driver_find_device";
"driver_for_each_device";
"driver_get_bia";
"driver_probe_device";
"driver_register";
"driver_remove_file";
"driver_unregister";
"eth_change_mtu";
"ether_setup";
"eth_header";
"eth_header_cache";
"eth_header_cache_update";
"eth_header_parse";
"eth_mac_addr";
"eth_rebuild_header";
"ethtool_ntuple_flush";
"ethtool_op_get_flags";
"ethtool_op_get_link";
"ethtool_op_get_sg";
"ethtool_op_get_tso";
"ethtool_op_get_tx_csum";
"ethtool_op_get_ufo";
"ethtool_op_set_flags";
"ethtool_op_set_sg";
"ethtool_op_set_tso";
"ethtool_op_set_tx_csum";
"ethtool_op_set_tx_hw_csum";
"ethtool_op_set_tx_ipv6_csum";
"ethtool_op_set_ufo";
"eth_type_trans";
"eth_validate_addr";
"netif_rx";
"netif_carrier_off"; 
"netif_carrier_on"; 
"netif_device_attach"; 
"netif_device_detach"; 
"netif_napi_add"; 
"netif_napi_del"; 
"netif_receive_skb"; 
"netif_rx"; 
"netif_rx_ni"; 
"__netif_schedule"; 
"netif_set_real_num_rx_queues"; 
"netif_set_real_num_tx_queues"; 
"netif_stacked_transfer_operstate"; 




"kobject_action_type";
"kobject_add";
"kobject_create";
"kobject_create_and_add";
"kobject_del";
"kobject_get";
"kobject_get_path";
"kobject_init";
"kobject_init_and_add";
"kobject_move";
"kobject_put";
"kobject_rename";
"kobject_set_name";
"kobject_set_name_vargs";
"kobject_uevent";
"kobject_uevent_env";


"__kfree_skb";
"kfree_skb";
"class_compat_create_link";
"class_compat_register";
"class_compat_remove_link";
"class_compat_unregister";
"__class_create";
"class_create_file";
"class_destroy";
"classes_init";
"class_find_device";
"class_for_each_device";
"class_interface_register";
"class_interface_unregister";
"__class_register";
"class_remove_file";
"class_unregister";
"wireless_send_event";
"wireless_spy_update";
"x86_dma_fallback_dev";
"tr_type_trans";
"pri_reselect_tbl";
"proto_register";
"proto_unregister";
"consume_skb";
"icmp_send";
"icmpv6_send";
"bsg_register_queue";
"bsg_unregister_queue";
"__sg_alloc_table";
"sg_copy_from_buffer";
"sg_copy_to_buffer";
"sget";
"__sg_free_table";
"sg_init_one";
"sg_init_table";
"sg_miter_next";
"sg_miter_start";
"sg_miter_stop";
"sg_next";
"sg_scsi_ioctl";
"sk_alloc";
"skb_abort_seq_read";
"sk_chk_filter";
"sk_free";
"sk_receive_skb";
"sk_run_filter";
"sound_timer_devs";
"__starget_for_each_device";
"starget_for_each_device";
"submit_bio";
"suspend_device_irqs";
"sync_blockdev";
"synchronize_irq";
"synchronize_net";
"sync_page_io";
"dlci_ioctl_set";

"set_device_ro";
"set_disk_ro";
"resume_device_irqs";
"resume_next_sg";
"freeze_bdev";
(* kernel device lib *)

"attribute_container_add_class_device";
"attribute_container_add_device";
"attribute_container_class_device_del";
"attribute_container_classdev_to_container";
"attribute_container_device_trigger";
"attribute_container_find_class_device";
"attribute_container_register";
"attribute_container_remove_device";
"attribute_container_unregister";
"system_bus_init";
"__start_builtin_fw";
];;

let timer_fns: string list =
[
"get_seconds";
"add_timer";
"mod_timer";
"del_timer";
"usecs_to_jiffies";
"jiffies";
"current_fs_time";
"current_kernel_time";
"jiffies_64";
"jiffies_64_to_clock_t";
"jiffies_to_msecs";
"jiffies_to_timespec";
"jiffies_to_timeval";
"jiffies_to_usecs";
"round_jiffies";
"round_jiffies_relative";
"round_jiffies_up";
"usecs_to_jiffies";
"timecompare_transform";
"__timecompare_update";
"timecounter_cyc2time";
"timecounter_init";
"timer_event";
"timer_irq";
"timeval_usec_diff";
"timecompare_transform";
"__timecompare_update";
"timecounter_cyc2time";
"timecounter_init";
"timer_event";
"timeval_usec_diff";
"__ndelay";
"__udelay";
"sys_tz";
"getnstimeofday";
"msleep";
"msleep_interruptible";
"sleep_on";
"sleep_on_timeout";
"interruptible_sleep_on";
"interruptible_sleep_on_timeout";
"__const_udelay";
"do_gettimeofday";
"hrtimer_init";
"hrtimer_start";
"init_timer_deferrable_key";
"init_timer_key";

];;


let unclass_fns: string list =
  [






];;


let sync_functions:string list = thread_functions@event_functions;;
(* let kernel_helper_libs: string list = alloc_fns@alloc_dev@sync_functions@kernel_helper_libs1@timer_fns;; *) 
(* let kernel_fns: string list = kernel_helper_libs@kernel_dev_libs;;*) 
let kernel_helper_libs: string list = kernel_helper_libs1@timer_fns;;
let kernel_dev_libs = kernel_dev_libs@alloc_dev;; 
(* let kernel_fns: string list = kernel_helper_libs@kernel_dev_libs@alloc_fns@alloc_dev@sync_functions;; *) 
let device_fns: string list = mmio_functions@portio_fns@dmaio_fns;;
let bus_functions:string list = other_bus_functions@acpi_bus_functions;;


let driver_libs = [
"genphy_config_aneg";
"genphy_read_status";
"genphy_resume";
"genphy_suspend";
"genphy_update_link";
"audio_init_devices";
"audio_ioctl";
"audio_open";
"audio_read";
"audio_release";
"audio_write";
"get_phy_device"; 
];;


let kernel_services = [
"generic_access_phys";
"generic_delete_inode";
"generic_file_aio_read";
"generic_make_request";
"generic_mii_ioctl";
"generic_rndis_bind";
"generic_show_options";
"generic_shutdown_super";
"generic_unplug_device";

"genl_register_family";
"genl_register_mc_group";

"genl_unregister_family";
"get_adapter_list_head";
"get_all_Bprotocols";
"get_cmd_string";
"getconsxy";
"get_container_type";
"get_cpu_sysdev";
"get_ctrl_string";
"get_dcookie";
"get_default_font";
"get_device";
"get_disk";
"get_driver";
"get_field";
"__get_free_pages";

"getkeycode";
"getledstate";
"get_mdevice";
"get_mdevice_count";
"get_mgmt_string";
"get_mtd_device";
"get_mtd_device_nm";
"get_next_bframe";
"get_next_dframe";

"hal_mod_fcpim";
"hal_mod_fcport";
"hal_mod_fcxp";
"hal_mod_lps";
"hal_mod_rport";
"hal_mods";
"hal_mod_sgpg";
"hal_mod_uf";
"init_plc";
"__init_rwsem";
"init_smt";
"init_special_inode";
"init_task";
"init_uts_ns";
"boot_cpu_data";
"boot_option_idle_override";
"boot_tvec_bases";
"build_phys_page_list";
"byte_rev_table";
"cache_k8_northbridges";
"anon_inode_getfile";
"anon_transport_class_register";
"anon_transport_class_unregister";
"setkeycode";
"set_memory_uc";
"set_memory_wb";
"set_memory_wc";
"set_normalized_timespec";
"set_page_dirty";
"set_page_dirty_lock";
"set_pages_array_uc";
"set_pages_array_wb";
"set_pages_uc";
"set_pages_wb";
"set_port_type";
"set_selection";
"set_translate";
"set_selection";
"set_translate";
"set_user_nice";
"sha_init";
"sha_transform";
"shift_state";
"shiftx";
"shmem_file_setup";
"shmem_zero_setup";
"show_class_attr_string";
"show_iwmct_log_level";
"show_iwmct_log_level_fw";
"show_mem";
"show_regs";
"show_state_filter";
"sigprocmask";
"si_meminfo";
"simple_attr_open";
"simple_attr_read";
"simple_attr_release";
"simple_attr_write";
"simple_dir_inode_operations";
"simple_dir_operations";
"simple_map_init";
"simple_pin_fs";
"simple_read_from_buffer";
"simple_release_fs";
"simple_set_mnt";
"simple_statfs";
"single_release";
"skip_spaces";
"soft_cursor";
"splice_direct_to_actor";
"__splice_from_pipe";
"splice_from_pipe";
"start_cpu_work";
"__suspend_report_result";
"suspend_set_ops";
"__symbol_get";
"__symbol_put";
"symbol_put_addr";
"synchronize_sched";
"sync_start";
"sync_stop";
"sys_copyarea";
"sys_ioperm";
"sysrq_timer_list_show";
"system_has_dca_enabled";
"system_state";
"taskfile_lib_get_identify";
"proc_create_data";
"proc_details";
"proc_dointvec";
"proc_dointvec_minmax";
"proc_dostring";
"proc_doulongvec_ms_jiffies_minmax";
"proc_mkdir";
"proc_net_remove";
"proc_symlink";
"find_vma";
"find_vpid";
"finish_wait";

"__FIXADDR_TOP";
"cpu_all_bits";
"cpu_bit_bitmap";
"cpu_dev_init";
"cpu_online_mask";
"cpu_possible_mask";
"cpu_present_mask";
"cpu_sysdev_class";

"async_gen_syndrome";
"async_memcpy";
"async_raid6_2data_recov";
"async_raid6_datap_recov";
"async_schedule";
"async_synchronize_cookie";
"async_synchronize_full";
"async_syndrome_val";
"async_trigger_callback";
"async_xor";
"async_xor_val";
"execute_in_process_context";
"extend_brk";
"fasync_helper";
"fget";
"file_kill";
"file_move";
"files_lock";
"file_update_time";
"fill_inquiry_response";
"filp_close";
"filp_open";
"filter_current_check_discard";
"vfs_fsync";
"vfs_getattr";
"vfs_read";
"vfs_write";
"vmap";
"vm_get_page_prot";
"vm_insert_mixed";
"vm_insert_page";
"vm_insert_pfn";
"volume_boost";
"vunmap";
"vwrite";
"warn_slowpath_fmt";
"warn_slowpath_null";
"kick_iocb";
"kill_anon_super";
"kill_fasync";
"kill_litter_super";
"kill_pgrp";
"kill_pid";
"kill_pid_info_as_uid";
"unlock_page";
"unmap_mapping_range";
"update_console_cmdline";
"update_interval";
"update_region";
"urandom_fops";
"usermode_helper";
"x86_mce_decoder_chain";
"xlate_dev_mem_ptr";
"yield";
"totalram_pages";

"unlock_page";
"unmap_mapping_range";

"update_console_cmdline";
"update_interval";

"urandom_fops";
"use_internal_drums";
"usermode_helper";
"use_spi_crc";
"utf16s_to_utf8s";

"vesa_modes";
"sys_ioperm";
"sysrq_timer_list_show";
"system_bus_init";
"system_has_dca_enabled";
"system_state";
"take_over_console";
"taskfile_lib_get_identify";
"task_handoff_register";
"task_handoff_unregister";
"unblock_all_signals";
"native_set_fixmap";
"__ndelay";
"node_info";
"nodemgr_dev_template_host";
"nodemgr_for_each_host";
"no_llseek";
"unblock_all_signals";
"nonseekable_open";
"normalize_rt_tasks";
"note_interrupt";
"NR_TYPES";
"ns_to_timeval";
"option_ms_init";
"orderly_poweroff";
"out_of_line_wait_on_bit";
"out_of_memory";
"page_address";
"pagecache_write_begin";
"pagecache_write_end";
"page_mkclean";
"panic";
"panic_blink";
"panic_notifier_list";
"panic_on_oops";

"path_put";
"pc_debug";
"put_cmsg";
"putconsxy";
"put_pid";
"put_unused_fd";
"__put_user_1";
"__put_user_2";
"__put_user_4";
"__put_user_8";
"current_task";
"d_alloc_name";
"d_alloc_root";
"datagram_poll";
"dbg_pnp_show_option";
"dbg_pnp_show_resources";
"dcache_lock";
"dcdbas_smi_request";
"dchannel_senddata";
"dcookie_register";
"dcookie_unregister";
"d_delete";
"deactivate_locked_super";
"default_backing_dev_info";
"default_mtd_writev";

"default_blu";
"default_grn";
"default_idle";
"default_red";
"default_sound_timer";
"default_tp_ops";
"default_utf8";
"default_wake_function";
"deinit_kmem_cache";
"delete_channel";
"delete_stack";
"delete_teimanager";
"del_gendisk";
"dentry_unhash";
"dequeue_signal";
"destroy_hw_obj";
"destroy_port";
"detach_capi_ctr";
"determine_fw_capabilities";
"ir_register_class";
"ir_unregister_class";
"isa_dma_bridge_buggy";
"is_aoe_netif";
"is_current_pgrp_orphaned";
"kernel_getpeername";
"kernel_getsockname";
"kernel_power_off";
"kernel_recvmsg";
"kernel_sendmsg";
"kernel_sock_shutdown";
"kern_path";
"keventd_up";
"keyboard_tasklet";
"keymap_count";
"key_maps";
"kmap";
"kmap_atomic";
"kmap_atomic_prot";
"kmsg_dump_register";
"kmsg_dump_unregister";
"kref_get";
"kref_init";
"kref_put";
"kset_create_and_add";
"kset_find_obj";
"kset_init";
"kset_register";
"kset_unregister";
"kstat";
"kunmap";
"kunmap_atomic";

"linkwatch_fire_event";
"lis3_dev";
"lock_fb_info";
"__lock_page";
"lock_sock_nested";
"lookup_bdev";
"lookup_one_len";
"loop_register_transfer";
"loop_unregister_transfer";
"map_destroy";
"mark_page_accessed";
"mark_tsc_unstable";

"create_proc_entry";
"create_stack";
"__create_workqueue_key";
"csum_partial";
"csum_partial_copy_generic";
"_ctype";
"d_instantiate";
"disable_hlt";
"disable_mpa_crc";
"DisableRamdacOutput";
"DisableVGA";
"disk_stack_limits";
"dummy_con";
"do_ide_request";
"do_l2t_write_rpl";
"do_map_probe";
"do_mmap_pgoff";
"do_munmap";
"do_poke_blanked_console";
"do_rw_taskfile";
"__do_SAK";
"do_SAK";
"do_suspend_lowlevel";
"do_sync_read";
"do_sync_write";
"do_unblank_screen";
"d_path";
"dp_link_train";
"dpm_sysfs_add";
"dpm_sysfs_remove";
"dput";
"emergency_remount";
"emergency_restart";
"emergency_sync";
"emergency_thaw_all";
"enabled_str";
"enable_faults";
"enable_hlt";

"__end_builtin_fw";
"end_cpu_work";
"errata";
"error_mask1";
"error_mask2";
"force_monitor";
"force_sig";
"formac_reinit_tx";
"formac_tx_restart";

"fput";
"freq_reg_info";
"__f_setown";
"edd";
"edid_info";


"format_by_fourcc";
"ftrace_event_seq";
"func_buf";
"funcbufleft";
"funcbufptr";
"funcbufsize";
"func_table";
"dummy_regulator_rdev";
"_dump_buf_data";
"_dump_buf_data_order";
"_dump_buf_dif";
"_dump_buf_dif_order";
"_dump_buf_done";
"_dump_buf_lock";

"clockevents_notify";
"close_bdev_exclusive";
"cmp_break_pp_connection";
"cmp_establish_pp_connection";
"color_table";
"complement_pos";
"compute_shiftstate";
"_cond_resched";
"config_drive_for_dma";
"config_group_init";
"config_item_get";
"config_item_init_type_name";
"config_item_put";
"config_mux";
"conf_ilist";
"congestion_wait";
"read_address";
"read_cache_page";
"read_cache_page_gfp";
"read_dev_sector";
"redirected_tty_write";
"redraw_screen";
"refrigerator";
"reset_devices";
"resource_alignment";
"restore_bitmap_write_access";
"resync_timer_fn";
"revalidate_disk";
"round_off_xres";
"round_off_yres";
"rpipe_ep_disable";
"rq_size";
"rtm_set_timer";
"screen_info";
"screen_pos";
"scrollback";
"scrollfront";
"sel_loadlut";
"send_first";
"send_sig";
"send_sig_info";
"session_of_pgrp";
"set_aoe_iflist";
"set_bdi_congested";
"set_blocksize";
"set_channel_address";
"set_field";
"set_flag_le64";
"set_formac_tsync";
"int_to_scsilun";
"invalidate_bdev";
"invalidate_bh_lrus";
"invalidate_mapping_pages";
"bmap";
"cache_k8_northbridges";
"call_rcu";
"can_do_mlock";
"capable";
"change_console";
"channel_of_freq";
"check_interval";
"check_signature";
"check_wakeup_irqs";
"interrupt_mod_interval";
"debugfs_create_bool";
"debugfs_create_dir";
"debugfs_create_file";
"debugfs_create_u32";
"debugfs_create_u8";
"debugfs_create_x32";
"debugfs_create_x8";
"debugfs_remove";
"debugfs_remove_recursive";
"audit_log_end";
"audit_log_format";
"audit_log_lost";
"audit_log_n_hex";
"audit_log_start";
"audit_log_untrustedstring";
"max_mtu";



];;

let kernel_fns = kernel_services;;

(* This line is very very important *)
let all_basic_fns:string list = kernel_helper_libs@kernel_dev_libs@alloc_fns@alloc_dev@sync_functions@kernel_fns@device_fns@bus_functions;; 
